import logging
import subprocess


def shell_run(command, raw_output=True, **kwargs):
    error = ''
    output = ''
    if isinstance(command, str):
        kwargs['shell'] = True
    try:
        process = subprocess.run(command, check=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, universal_newlines=True, **kwargs)
    except subprocess.SubprocessError as e:
        error = str(e)
        logging.getLogger().warning(f'Warning from running {command}: {error}')
    except Exception as e:
        error = str(e)
        logging.getLogger().warning(f'Unknown error from {command}: {error}')
    if process and getattr(process, 'stdout', None):
        output = process.stdout
    return output, error
